<?php
/**
 * Copyright © 2016 Filoblu S.r.l. All rights reserved.
 */

namespace FiloBlu\ExtInventory\Block\Adminhtml\System\Config;

/**
 * Renderer for Event Configuration
 */

class MatrixSource extends \Magento\Config\Block\System\Config\Form\Field\FieldArray\AbstractFieldArray
{

    /**
     * @var AllSourcesFactory
     */
    protected $allSourcesFactory;

    /**
     * @param AllSourcesFactory $allSourcesFactory
     * @param \Magento\Backend\Block\Template\Context $context
     * @param array $data
     */
    public function __construct(
        \FiloBlu\ExtInventory\Block\Adminhtml\System\Config\AllSourcesFactory $allSourcesFactory,
        \Magento\Backend\Block\Template\Context $context,
        array $data = []
    ) {
        $this->allSourcesFactory = $allSourcesFactory;
        parent::__construct($context, $data);
    }

    /**
     * Enable the "Add after" button or not
     *
     * @var bool
     */
    protected $_addAfter = false;

    /**
     * Rows cache
     *
     * @var array|null
     */
    private $_arrayRowsCache;

    /**
     * Prepare to render
     *
     * @return void
     */
    protected function _prepareToRender()
    {


        $sources = $this->allSourcesFactory->create()->toOptionArray();

        $initialSourcesBlock = $this->getLayout()->createBlock('Magento\Framework\View\Element\Html\Select')
            ->setId($this->_getCellInputElementId('<%- _id %>','initial_source'))
            ->setName($this->_getCellInputElementName('initial_source'))
            ->setClass('select')
            ->setOptions($sources);

        $finalSourcesBlock = $this->getLayout()->createBlock('Magento\Framework\View\Element\Html\Select')
            ->setId($this->_getCellInputElementId('<%- _id %>','final_source'))
            ->setName($this->_getCellInputElementName('final_source'))
            ->setClass('select')
            ->setOptions($sources);

        $this->addColumn('initial_source', array(
            'label' => __('Initial Source'),
            'renderer' => $initialSourcesBlock
        ));

        $this->addColumn('final_source', array(
            'label' => __('Final Source'),
            'renderer' => $finalSourcesBlock
        ));

        $this->_addButtonLabel = __('Add Source Mapping');
    }

}

